//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2021 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package objects

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// ObjectsReferencesCreateReader is a Reader for the ObjectsReferencesCreate structure.
type ObjectsReferencesCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ObjectsReferencesCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewObjectsReferencesCreateOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewObjectsReferencesCreateUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewObjectsReferencesCreateForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewObjectsReferencesCreateUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewObjectsReferencesCreateInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewObjectsReferencesCreateOK creates a ObjectsReferencesCreateOK with default headers values
func NewObjectsReferencesCreateOK() *ObjectsReferencesCreateOK {
	return &ObjectsReferencesCreateOK{}
}

/*ObjectsReferencesCreateOK handles this case with default header values.

Successfully added the reference.
*/
type ObjectsReferencesCreateOK struct {
}

func (o *ObjectsReferencesCreateOK) Error() string {
	return fmt.Sprintf("[POST /objects/{id}/references/{propertyName}][%d] objectsReferencesCreateOK ", 200)
}

func (o *ObjectsReferencesCreateOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewObjectsReferencesCreateUnauthorized creates a ObjectsReferencesCreateUnauthorized with default headers values
func NewObjectsReferencesCreateUnauthorized() *ObjectsReferencesCreateUnauthorized {
	return &ObjectsReferencesCreateUnauthorized{}
}

/*ObjectsReferencesCreateUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type ObjectsReferencesCreateUnauthorized struct {
}

func (o *ObjectsReferencesCreateUnauthorized) Error() string {
	return fmt.Sprintf("[POST /objects/{id}/references/{propertyName}][%d] objectsReferencesCreateUnauthorized ", 401)
}

func (o *ObjectsReferencesCreateUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewObjectsReferencesCreateForbidden creates a ObjectsReferencesCreateForbidden with default headers values
func NewObjectsReferencesCreateForbidden() *ObjectsReferencesCreateForbidden {
	return &ObjectsReferencesCreateForbidden{}
}

/*ObjectsReferencesCreateForbidden handles this case with default header values.

Forbidden
*/
type ObjectsReferencesCreateForbidden struct {
	Payload *models.ErrorResponse
}

func (o *ObjectsReferencesCreateForbidden) Error() string {
	return fmt.Sprintf("[POST /objects/{id}/references/{propertyName}][%d] objectsReferencesCreateForbidden  %+v", 403, o.Payload)
}

func (o *ObjectsReferencesCreateForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ObjectsReferencesCreateForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewObjectsReferencesCreateUnprocessableEntity creates a ObjectsReferencesCreateUnprocessableEntity with default headers values
func NewObjectsReferencesCreateUnprocessableEntity() *ObjectsReferencesCreateUnprocessableEntity {
	return &ObjectsReferencesCreateUnprocessableEntity{}
}

/*ObjectsReferencesCreateUnprocessableEntity handles this case with default header values.

Request body is well-formed (i.e., syntactically correct), but semantically erroneous. Are you sure the property exists or that it is a class?
*/
type ObjectsReferencesCreateUnprocessableEntity struct {
	Payload *models.ErrorResponse
}

func (o *ObjectsReferencesCreateUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /objects/{id}/references/{propertyName}][%d] objectsReferencesCreateUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *ObjectsReferencesCreateUnprocessableEntity) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ObjectsReferencesCreateUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewObjectsReferencesCreateInternalServerError creates a ObjectsReferencesCreateInternalServerError with default headers values
func NewObjectsReferencesCreateInternalServerError() *ObjectsReferencesCreateInternalServerError {
	return &ObjectsReferencesCreateInternalServerError{}
}

/*ObjectsReferencesCreateInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type ObjectsReferencesCreateInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *ObjectsReferencesCreateInternalServerError) Error() string {
	return fmt.Sprintf("[POST /objects/{id}/references/{propertyName}][%d] objectsReferencesCreateInternalServerError  %+v", 500, o.Payload)
}

func (o *ObjectsReferencesCreateInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ObjectsReferencesCreateInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
